public class SearchTree<T extends Comparable<T>> {

    private class Node {
	T    value;
        Node left;
	Node right;

	Node(T val) {
	    value = val;
	    left = null;
	    right = null;
	}
    }

    private Node root;
    private int size;

    public SearchTree() {
        root = null;
	size = 0;
    }

    public int size() {
        return size;
    }

    public boolean contains(T elem) {
        Node node = root;
        int  diff;

	while (node != null) {
	    diff = node.value.compareTo(elem);
	    if (diff == 0) {
	        return true;
	    }
	    else if (diff>0) {
	        node = node.left;
	    }
	    else {
	        node = node.right;
	    }
	}

	return false;
    }

    public void insert(T elem) {
        Node node = root;
	Node father = null;
	int  diff=0;

	while (node!=null) {
	    father = node;
	    diff = node.value.compareTo(elem);
	    if (diff==0) {
	        return;
	    }
	    else if (diff>0) {
	        node = node.left;
	    }
	    else {
	        node = node.right;
	    }
	}

	node = new Node(elem);

	if (father==null) {
	   root = node;
	}
	else if (diff>0) {
	    father.left = node;
	}
	else {
	    father.right = node;
	}

	size++;
    }
}
